%% Inputs
Computing_option = 'ParallelComputing';   % Choices :  'SingleComputing'  'ParallelComputing'
Ida_path='"c:\program files (x86)\IDA\bin\' % Location of Ida-Ice folder
Temp_File_Location='E:\Temp\idamod47'; % must be set in IDA-ICE
Work_Folder_Location='"C:\SA Script\';%'"C:\kindergarten\SimpleModel\';
Building_Model_Location='"C:\SA Script\building1.idm"'; % building model location

%% Outputs - 
% Outputs can be added by comparing outputs in IDA-ICE interface with the
% outputfile IDA_LISP.END and adding them as variables as done below.

Output_Variable_Names {1} = ('  Emeter_13.Totenergy'); %PV-produced
Output_Variable_Names {2} = ('  Emet_net_13.Totenergy'); %PV exported
Output_Variable_Names {3} = ('  Emeter_1.Totenergy');  % Annual Lighting
Output_Variable_Names {4} = ('  Emeter_10.Totenergy'); % Annual Fuel Heating
Output_Variable_Names {5} = ('  Emeter_12.Totenergy'); % Annual Domestic Hot water
Output_Variable_Names {6} = ('  Emeter_4.Totenergy');  % Annual Equipment tenant
Output_Variable_Names {7} = ('  Emeter_9.Totenergy');% Annual electric heating
Output_Variable_Names {8} = ('  Emeter_8.Totenergy');%HVAX AUX
Output_Variable_Names {9} = ('  Emeter_5.Totenergy') %annual electric cooling

 


%% Assigning Inputs in array (preparation steps)
Project_Paths_Names {1} = [Ida_path,'ida-ice.exe" '] ;
Project_Paths_Names {2} = [Ida_path,'ida.img" '] ;
Project_Paths_Names {3} = Work_Folder_Location ;  % working folder
Project_Paths_Names {4} = strrep(Work_Folder_Location, '\', '\\');   % working folder with \\ for IDA script  %%%% strrep..replace......
Project_Paths_Names {5} = strrep(Building_Model_Location, '\', '\\'); % IDA-project location for IDA Script
Project_Paths_Names {6} = Temp_File_Location; %temp folder set in IDA


%% Collectin design variables and create the simlab sample file

Design_variable_names = Collect_design_variables; % Collects names from Diff_script
%write_genconfig;         %Creates the factor file with names from diff_script

% the m.file ( write_genconfig) creates file (i.e., genconfig)  for SIMLAB 4
% FYI: SIMLAB needs inputs which can be provided manually using the
% software interface of automatically using load configuration (i.e., genconfig) 

% please go to SIMLAB NOW to do the following (but please keep SIMLAB opened) to generate the sample file ......... 
% 1: upload the (i.e., genconfig) 
% 2. change mean, sd, .........etc
% 3. identify the sampling method and Sample size , etc
% 4. generate and save whole sample using the button called ''generate and save whole sample''


% Prompts user for creating samplefile in simlab
while(1)
    disp('Is the samplefile created, and saved as SamplFile_SimLab.sam?')
    choice=input('Continue? Y/N:','s')
    if choice=='Y' | choice=='y'
        break;
    end
end

%%This Open the generated sample file in MATLAB
Sam=opensam('SampleFile_SimLab.sam'); % Opens sample file from Simlab
%Sam(:,16)=round(Sam(:,16),2);


%% Simulation Engine (i.e., IDA ICE)
tic

N= size(Sam,1);% number of raws '' sample size '' = number of simulations 
M=size(Sam,2);% number of col  '' number of design variables ''
L=length(Output_Variable_Names);
ModelOutput=zeros(N,L);
parfor SimNum=1:N
    Create_new_batches(SimNum,Project_Paths_Names);% this creates  new batch files ('Resp_batch' & 'run_ida') and paths  in parallel 
    DesignVariables_Names=Change_DesignVariables(Sam(SimNum,:),SimNum);
    
    % we need those ''Run_Ida'' and '' Resp_batch'' and '' '' because we handle several ''Run_ida'' file and ''resp_batch'' files
    Run_Ida=['run_ida',num2str(SimNum),'.bat'] % Creating different Run_ida files
    Resp_batch=['Resp_batch',num2str(SimNum),'.bat'] % Creating different batches
    diff_script=['diff_script',num2str(SimNum),'.cms']
    %'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    system(Run_Ida); % all the parallell simulation runs at this folder ''Work_Folder_Location'' 
    for j=3:L; %starts a 3. no pv system in the model.
        ModelOutput(SimNum,j)=CollectOut(Output_Variable_Names{j},(Project_Paths_Names{6}),SimNum); % columns shows the output variables 
    end
    delete(Resp_batch);
    delete(Run_Ida);
    delete(diff_script);
end
time=toc
%% Write outputs in readable form
b=ModelOutput(:,7)+ModelOutput(:,9)
outfix('sim_out.txt',b,'Simulation_outputs') % Here I give the simulation results back to SIMLAB in order to make sensitivity analysis
% Using the function outfix to create SimLab4 formated text file from simulation outputs
fclose('all')       ;        %close all open files
disp('open the sim_out.txt in SimLab4 and run the Monte Carlo analysis')

%%
% 1. create a Sample using SIMLAB
% 2. run the sample using IDA ICE 
% 3. the the results back to SIMLAB 
% 4. run seensitivity analysis using SIMLAB by giving the sample's inputs (prepared by SIMLAB) and outputs (results of IDA ICE)
